// TestLog.h : Declaration of the CTestLog

#ifndef __TESTLOG_H_
#define __TESTLOG_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTestLog
class ATL_NO_VTABLE CTestLog : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTestLog, &CLSID_TestLog>,
	public IDispatchImpl<ITestLog, &IID_ITestLog, &LIBID_TESTSERVERLib>
{
public:
	CTestLog()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TESTLOG)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTestLog)
	COM_INTERFACE_ENTRY(ITestLog)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ITestLog
public:
	STDMETHOD(DoSomething)();
};

#endif //__TESTLOG_H_
