// Hello.cpp : Implementation of DLL Exports.

#include "stdafx.h"
#include "resource.h"
#include "Hello.h"

class CHelloModule : public CAtlDllModuleT< CHelloModule >
{
public :
	DECLARE_LIBID(LIBID_HelloLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_HELLO, "{2DF9D863-DF4C-4EA1-A10B-90C4E0A38B5C}")
};

CHelloModule _AtlModule;

class CHelloApp : public CWinApp
{
public:

// Overrides
    virtual BOOL InitInstance();
    virtual int ExitInstance();

    DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CHelloApp, CWinApp)
END_MESSAGE_MAP()

CHelloApp theApp;

BOOL CHelloApp::InitInstance()
{
    return CWinApp::InitInstance();
}

int CHelloApp::ExitInstance()
{
    return CWinApp::ExitInstance();
}


// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (AfxDllCanUnloadNow()==S_OK && _AtlModule.GetLockCount()==0) ? S_OK : S_FALSE;
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    HRESULT hr = _AtlModule.DllRegisterServer();
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer();
	return hr;
}
