//Copyright (C) KLA-Tencor (ASD Division),  1999. All rights reserved.   

#ifndef GIT_H
#define GIT_H

template <class Itf,const IID* piid>
class CGlobalInterfaceTable
{
public:
   CGlobalInterfaceTable();
   ~CGlobalInterfaceTable();
   HRESULT Register(Itf* pInterface,DWORD *pdwCookie);
   HRESULT Revoke(DWORD dwCookie);
   HRESULT GetInterface(DWORD dwCookie,Itf** ppInterface);

protected:
   IGlobalInterfaceTable* m_pGlobalInterfaceTable;


private://prevent misuse
   CGlobalInterfaceTable(const CGlobalInterfaceTable&);
   void operator =(const CGlobalInterfaceTable&);

};

#define GIT(Itf) CGlobalInterfaceTable<Itf,&IID_##Itf>
#include "GIT.inl"

#endif
