// CatalogAdmin.h : Declaration of the CCatalogAdmin

#ifndef __CATALOGADMIN_H_
#define __CATALOGADMIN_H_

#include "resource.h"       // main symbols
interface ICOMAdminCatalog;
/////////////////////////////////////////////////////////////////////////////
// CCatalogAdmin
class ATL_NO_VTABLE CCatalogAdmin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCatalogAdmin, &CLSID_CatalogAdmin>,
	public IDispatchImpl<ICatalogAdmin, &IID_ICatalogAdmin, &LIBID_NukemLib>
{
public:
	CCatalogAdmin();
	~CCatalogAdmin();
   void FinalRelease();
   HRESULT FinalConstruct();

DECLARE_REGISTRY_RESOURCEID(IDR_CATALOGADMIN)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCatalogAdmin)
	COM_INTERFACE_ENTRY(ICatalogAdmin)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICatalogAdmin
public:
	STDMETHOD(Start)(BSTR bstrAppName);
	STDMETHOD(ShutDown)(BSTR bstrAppName);

   ICOMAdminCatalog* m_pCatalog;
};

#endif //__CATALOGADMIN_H_
