// CBank.cpp : Implementation of CBank
#include "stdafx.h"
#include "Bank.h"
#include "mtx.h"
#include "comdef.h"
#include "CBank.h"

/////////////////////////////////////////////////////////////////////////////
// CBank


STDMETHODIMP CBank::TransferMoney(int nSum, DWORD dwAccountSrc, DWORD dwAccountDest)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

   HRESULT hres = S_OK;

   ISecurityCallContext* pSecurityCallContext = NULL;
   _bstr_t bstrRole = "Customer" ;
   VARIANT_BOOL bInRole = FALSE;
   hres = ::CoGetCallContext(IID_ISecurityCallContext,
                             (void**)&pSecurityCallContext);
   if(pSecurityCallContext == NULL)
   {
      //No security call context available, role-based security not in use
      return E_FAIL;
   }
   hres = pSecurityCallContext->IsCallerInRole(bstrRole,&bInRole);
   pSecurityCallContext->Release();
   if(bInRole)//The caller is a customer
   {
      if(nSum > 5000)
         return E_FAIL;
   }
   return DoTransfer(nSum,dwAccountSrc,dwAccountDest);//Helper method
}

STDMETHODIMP CBank::OpenAccount(DWORD *pdwAccount)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CBank::CloseAccount(DWORD dwAccount)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CBank::GetBalance(DWORD dwAccount,int *pnBalance)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CBank::Apply(DWORD dwAccount,BOOL* pbApproved)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CBank::CalcPayment(DWORD dwSum,DWORD* pdwPayment)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CBank::MakePayment(DWORD dwAccount,DWORD dwSum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

