// macro.h

#ifndef _MACRO_H_
#define _MACRO_H_

#define	RELEASE(p) if (p) { p->Release(); p = NULL; }

#define SAFERELEASE(p) RELEASE(p)

#define exit(hr) if FAILED(hr) goto exit;


#define ASSERT_AND_RETURN(hres)        {\
                                          ATLASSERT(SUCCEEDED(hres)); \
                                          if(FAILED(hres))            \
                                             return hres;             \
                                       }

#define EXIT(hres)        {\
                              ATLASSERT(SUCCEEDED(hres)); \
                              if(FAILED(hres))            \
                                   exit(hres);            \
                          }


#endif
